﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Threading;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using bbiwarg.Graphics;
using bbiwarg.InputProviders;

namespace bbiwarg
{
    class MainBBIWARG
    {
        static void Main(string[] args)
        {
            Console.SetWindowSize(Constants.ConsoleWidth, Constants.ConsoleHeight);

            InputProvider inputProvider;
            if (Constants.InputSource == InputType.Movie)
                inputProvider = new VideoInputProvider(Constants.InputMoviePath);
            else
                inputProvider = new InputProvider();

            inputProvider.start();


            InputHandler inputHandler = new InputHandler(inputProvider);

            OutputWindow outputWindow = new OutputWindow(inputProvider, inputHandler);
            outputWindow.Run(Constants.OutputUpdateRate, Constants.OutputRenderRate);

            inputProvider.stop();
        }
    }
}
